//---------------------------------------------------------------------------

#include "mex.h"
#include "matrix.h"
#include "math.h"
#include "stdlib.h"
#include "RDAAM_cylinder_ProDiff.h"
#include "RDAAM_cylinder_ProDiff.cpp"
//---------------------------------------------------------------------------

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    int i,ntimes;
    //int *nPro;
	double *ap_age, *ap_corrAge, *zr_age, *zr_corrAge, *tot_He, *outMatrix;
    vector<double> he_prof_cyl;
    double *temp,*time;
    float *rtemp,*rtime;
    double radius, coreRadius, zoneRatio, *U, *Th, *Sm;
	char dummy[255];
	char c;
    
    // input arguments
    time = mxGetPr(prhs[0]);
    ntimes = mxGetNumberOfElements(prhs[0]);
    temp = mxGetPr(prhs[1]);
    radius = mxGetScalar(prhs[2]);
    U = mxGetPr(prhs[3]);
    Th = mxGetPr(prhs[4]);
    Sm = mxGetPr(prhs[5]);
    
    
    TTPath path;
    path.clear();
    for (i=0;i<ntimes;i++) {
        TTPathPoint timetemp = {time[i],temp[i]};
        path.push_back(timetemp);
        }
    
    // output arguments
    plhs[0] = mxCreateDoubleMatrix(1,1, mxREAL);
    plhs[1] = mxCreateDoubleMatrix(1,1, mxREAL);
    plhs[2] = mxCreateDoubleMatrix(1,1, mxREAL);
    //plhs[3] = mxCreateNumericMatrix(1,1, mxINT32_CLASS, mxREAL);
    
    ap_corrAge = mxGetPr(plhs[0]);
    ap_age = mxGetPr(plhs[1]);
    tot_He = mxGetPr(plhs[2]);
    //nPro = (int*) mxGetData(plhs[3]);
    
    
// Run this first to set up the model.  Run again if you change one of the parameters
	RDAAM_Init(HE_PREC_GOOD, radius, U, Th, Sm); // precision, radius, U, Th, Sm
//	ZRDAAM_Init(HE_PREC_BEST, radius, coreRadius, zoneRatio, U, Th, Sm); // precision, radius, U, Th, Sm

// After RDAAM_Init is run, run this as many times as you want for each path to model
// Set final parameter (optimize) to true for geological histories, false for degassing
	int ap_success = RDAAM_Calculate(&path, *ap_age, *ap_corrAge, *tot_He, &he_prof_cyl, true);
//  int zr_success = RDAAM_Calculate(&path, *zr_age, *zr_corrAge, *tot_He, true);

    plhs[3] = mxCreateDoubleMatrix(1,he_prof_cyl.size(), mxREAL);

    outMatrix = mxGetPr(plhs[3]);
    for (i=0;i<he_prof_cyl.size();i++) {
        outMatrix[i] = he_prof_cyl[i];
    }

    //printf("Value of d = %d\n",he_prof_cyl.size());
    //printf("Value of d = %f\n",*tot_He);
    //printf("Value of radius = %f\n",radius);
    //printf("Value of core radius = %f\n",coreRadius);
    //printf("Value of d = %f\n",*he_prof_cyl);
    
	return;
}
//---------------------------------------------------------------------------

